SystemOrganization addCategory: #'Prolog-Base'!


ConsCell subclass: #PrologList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Notification subclass: #PrologAnswerStep
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #PrologOperator
	instanceVariableNames: 'operator precedence type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicRef
	instanceVariableNames: 'content term'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Association subclass: #LogicResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

LogicResult class
	instanceVariableNames: ''!

PrologList subclass: #Relation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

IdentityDictionary subclass: #PrologDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

PrologDatabase class
	instanceVariableNames: ''!

Object subclass: #LogicDontCare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

LogicDontCare class
	instanceVariableNames: ''!

Object subclass: #LogicUnbound
	instanceVariableNames: 'killer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

PrologAnswerStep class
	instanceVariableNames: ''!

PrologOperator class
	instanceVariableNames: ''!

Object subclass: #LogicUnification
	instanceVariableNames: 'terms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

PrologList class
	instanceVariableNames: ''!

LogicUnification class
	instanceVariableNames: ''!

LogicUnbound class
	instanceVariableNames: ''!

LogicRef class
	instanceVariableNames: ''!

Object subclass: #NamedLogicUnbound
	instanceVariableNames: 'term uhash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

NamedLogicUnbound class
	instanceVariableNames: ''!

Object subclass: #Logic
	instanceVariableNames: 'answer varList unboundVars returnBlock outputStream inputStream database'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'Prolog-Base'!

Logic class
	instanceVariableNames: ''!

Notification subclass: #PrologNoMatch
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

PrologNoMatch class
	instanceVariableNames: ''!

Relation class
	instanceVariableNames: ''!


!LogicResult commentStamp: 'spfa 9/27/2022 21:20' prior: 0!
A LogicResult wraps a LogicRef value for interactive printing. It maintains the term unified with the value.!
]style[(108)!

!PrologAnswerStep commentStamp: 'spfa 9/28/2022 00:39' prior: 0!
PrologAnswerStep signals an upcoming backtracking step during a Prolog inference!
]style[(80)!

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^true! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 11/18/2009 18:11'!
= anObject
    ^self logicValue = anObject! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 11/18/2009 18:11'!
== anObject
    ^self logicValue == anObject! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 11/18/2009 18:11'!
adaptToNumber: rcvr andSend: selector

	^ rcvr perform: selector with: self logicValue! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
addVarFrom: aList

    aList head isConsCell ifTrue: [self addVarFrom: aList head].

	{aList head . aList tail} do: [:part |
            (part class == LogicRef 
				and: [part logicValue class == LogicUnbound]
				and: [(varList identityIncludes: part) not])
            ifTrue: [varList add: part]].

	aList tail isConsCell ifTrue: [self addVarFrom: aList tail]! !

!PrologAnswerStep methodsFor: 'accessing' stamp: 'spfa 9/27/2022 21:45'!
answer

	^ answer! !

!PrologAnswerStep methodsFor: 'accessing' stamp: 'spfa 9/27/2022 21:45'!
answer: anArray

	answer := anArray! !

!LogicRef methodsFor: 'conversion' stamp: 'spfa 10/13/2022 15:12'!
asLogicResult: varList

	^ LogicResult new wrapAround: (self innerLogicResult: varList); term: term! !

!Relation methodsFor: 'as yet unclassified' stamp: 'spfa 9/27/2022 16:16'!
asLogicResults

	^ self! !

!Collection methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:08'!
asPrologList

	| cons |

	self size = 0 ifTrue: [^ nil].
	self size = 1 ifTrue: [^ PrologList car: (self at: 1) asPrologList].

	self reverseDo: [:elt | 
		cons := PrologList car: elt asPrologList cdr: cons].
	^ cons
! !

!ConsCell methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:08'!
asPrologList

	^ PrologList head: car asPrologList tail: cdr asPrologList! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:15'!
asPrologList

	^ self! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 11/18/2009 18:15'!
asPrologList

	^ self! !

!String methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:16'!
asPrologList

	^ self! !

!Symbol methodsFor: '*Prolog-Base' stamp: 'spfa 9/28/2022 14:25'!
asPrologList

	self == #~ ifTrue: [^ LogicRef newTerm: UUID new asString].
	self == #~~ ifTrue: [^ LogicDontCare new].
	^ self

! !

!Array methodsFor: '*Prolog-Base' stamp: 'spfa 10/13/2022 00:43'!
asPrologRelation

	| cons |

	self size = 0 ifTrue: [^ nil].
	self size = 1 ifTrue: [^ Relation car: (self at: 1) asPrologList].

	self reverseDoWithIndex: [:elt :n | 
		n = 1 
			ifTrue: [cons := Relation car: elt asPrologList cdr: cons]
			ifFalse: [cons := PrologList car: elt asPrologList cdr: cons]].
	^ cons
! !

!ConsCell methodsFor: '*Prolog-Base' stamp: 'spfa 10/11/2022 22:28'!
asPrologRelation

	^ self as: Relation! !

!LogicDontCare methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 22:30'!
asPrologRelation

	^ self ! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 22:29'!
asPrologRelation

	^ self ! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 10/11/2022 22:28'!
asPrologRelation

	^ Relation head: self tail: nil
! !

!Relation methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 22:26'!
asPrologRelation

	^ self ! !

!String methodsFor: '*Prolog-Base' stamp: 'spfa 10/11/2022 22:53'!
asPrologRelation

	^ Relation head: self tail: nil
! !

!PrologDatabase methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2022 09:14'!
assert: anArray

	^ self assertz: anArray! !

!PrologDatabase methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2022 09:06'!
asserta: anArray

	| relation list |

	relation := anArray asPrologList.

	list := self at: relation head ifAbsent: 
		[^ self at: relation head put: (PrologList car: relation tail)].
	list at: relation head put: (PrologList head: relation tail tail: list).

	^ self at: relation head! !

!PrologDatabase methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2022 09:06'!
assertz: anArray

	| relation |

	relation := anArray asPrologList.

	(self at: relation head ifAbsent: 
		[^ self at: relation head put: (PrologList car: relation tail)])
			addLast: relation tail.

	^ self at: relation head! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 11/18/2009 18:11'!
at: anObject
    ^self logicValue at: anObject! !

!Logic methodsFor: 'query' stamp: 'spfa 10/13/2022 16:23'!
buildQuery: aList
        "Private"
    | pred block |
    (pred := aList head asPrologRelation) ifNotNil: [self addVarFrom: pred].
    block := (aList tail ifNil: [[self inferAnswer: true]]
						ifNotNil: [self buildQuery: aList tail]).
    ^[self doGoal: pred onSuccess: block]! !

!Logic methodsFor: 'private' stamp: 'spfa 9/30/2022 13:37'!
check: assoc forArity: aNumber

	| n pred |

	pred := thisContext sender method selector.
	
	n := assoc key ifNil: [0] ifNotNil: [assoc key length].
	n = aNumber ifFalse: 
		[self error: pred, ' bad numbers of arguments (expected ', aNumber asString, ', given ', n asString,')'].! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content
    ^content! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content: anObject
    content := anObject! !

!Logic class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
database
    ^Database! !

!Logic methodsFor: 'query' stamp: 'spfa 10/3/2022 23:58'!
doGoal: aRelationOrSymbol continue: aBlock
	"Try to satisfy aRelationOrSymbol as a goal."

	self execute: (self doGoal: (self getGoal: aRelationOrSymbol) onSuccess: aBlock)! !

!Logic methodsFor: 'query' stamp: 'spfa 9/29/2022 14:56'!
doGoal: pred onSuccess: block

	^ self perform: (self class readPredicate: pred head) with: (pred tail -> block)! !

!Logic methodsFor: 'accessing' stamp: 'spfa 10/3/2022 14:57'!
doesNotUnderstand: aMessage

     | temp pred |

	"logicPREDICATE method or primlogicPREDICATE: primitive"
	(self class canUnderstand: 
		(temp := self class readPredicate: aMessage selector))
		ifTrue: [^ self perform: temp with: aMessage arguments first].

	"database lookup"
	pred := self database at: temp 
		ifAbsent: [^ self error: 'Undefined predicate: ', temp].

	^ self retrieve: aMessage arguments first from: pred
! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 11/18/2009 18:11'!
doesNotUnderstand: aMessage
    ^self logicValue
        perform: aMessage selector
        withArguments: aMessage arguments! !

!Logic methodsFor: 'private' stamp: 'spfa 9/29/2022 13:28'!
execute: aBlock

	| blk mark |
	mark := unboundVars size.
   	blk := aBlock.
	[(blk := blk value) isBlock] whileTrue.
	self unbindVar: mark! !

!Logic methodsFor: 'private' stamp: 'spfa 11/18/2009 18:11'!
first: assoc
        "Private -- Answer the first argument."
    ^ assoc key head logicValue
   ! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 10/3/2022 15:48'!
getValueFrom: anObject

    	| lastNode |

	lastNode := self lastNode.

	(anObject class == LogicRef
		and: [(anObject resorbBoundSlot) == lastNode]) ifTrue: [^ self].

	(lastNode content class == LogicUnbound) ifTrue: [
	"	self assert: lastNode content killer isNil." "sometimes invalidated - why? see Chapter5"

		(anObject class == LogicRef and: [anObject isUnbound]) ifFalse: [

		"fill the slot"
		lastNode content killer: anObject]].

	lastNode content: anObject! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 11/18/2009 18:15'!
head
    ^ car! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:17'!
head

	^ nil! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 11/18/2009 18:15'!
head: anObject
    self car: anObject! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
head: aObject tail: bObject
    ^self basicNew
        head: aObject;
        tail: bObject;
        yourself! !

!PrologOperator class methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 00:05'!
ifAnyFor: aString

	| ss |
	ss := aString asSymbol.
	^ (self named: ss) ifNil: [ss]! !

!Logic methodsFor: 'private' stamp: 'spfa 10/13/2022 16:23'!
inferAnswer: stoppable

	| unbounds udict |

	unbounds := OrderedCollection new.

	answer add: 
		(Array streamContents: [:str |
   			varList do: [:x | 
				(x class == LogicRef and: [x isUnbound]) 
					ifTrue: [unbounds add: x]
					ifFalse: [str nextPut: (x asLogicResult: varList)]].
		unbounds ifNotEmpty: [
			udict := OrderedDictionary new.
			unbounds do: [:x |
				(udict at: x logicValue ifAbsentPut: [OrderedCollection new]) add: x term].
			udict do: [:terms |
				terms size > 1 ifTrue: [
					str nextPut: (LogicUnification new terms: terms)]]]]).

	stoppable ifFalse: [^ self].

	"Catch the notification to suspend backtracking at this point"
	(PrologAnswerStep new answer: answer last) signal.
! !

!Logic methodsFor: 'private' stamp: 'spfa 10/1/2022 14:40'!
inferSmalltalk: aPrologList

        "Private -- Handle query from Smalltalk"

    varList := OrderedCollection new.
    answer := OrderedCollection new.
    returnBlock := [
        self unbindVar: 0.
        answer size = 0
            ifTrue: [^nil]
            ifFalse: [^answer asArray]].
    self execute: (self buildQuery: aPrologList).
    ^returnBlock value! !

!Logic class methodsFor: 'initialize-release' stamp: 'spfa 9/26/2022 09:05'!
initialize
        "Initialize Database."
    Database := PrologDatabase new! !

!Logic methodsFor: 'initialization' stamp: 'mt 6/28/1999 12:00'!
initialize
        "Private -- Initialize instance variables."
    unboundVars := OrderedCollection new: 2000! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 10/3/2022 23:32'!
innerLogicResult

	^ self logicInstanciated! !

!LogicRef methodsFor: 'conversion' stamp: 'spfa 10/13/2022 15:17'!
innerLogicResult: varList

	self isAutoReferential ifTrue: [^ self logicValue].

	self isUnbound ifTrue: [ | nt |
		nt := (varList identityIncludes: self) ifTrue: [term] ifFalse: ['_'].
		^ NamedLogicUnbound new term: nt; uhash: self logicInstanciated hash].

	^ self logicValue innerLogicResult: varList! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 10/13/2022 15:12'!
innerLogicResult: varList

	^ self logicInstanciated! !

!PrologList methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 15:12'!
innerLogicResult: varList

	^ self class 
		head: (self head innerLogicResult: varList)
		tail: (self tail innerLogicResult: varList)
   ! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
inputStream

	^ inputStream ifNil: [inputStream := ReadWriteStream on: '']! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
inputStream: aReadStream

	inputStream := aReadStream! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 11:39'!
isAutoReferential

	^ self isAutoReferentialWith: (Set with: self)! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 11:59'!
isAutoReferentialWith: aSet

	| v |

	v := self logicValue.
	(aSet identityIncludes: v) ifTrue: [^ true].
	v isPrologList ifFalse: [^ false].

	v hyperTreeDo: [:ea | 
		(aSet identityIncludes: ea) ifTrue: [^ true].
		((ea class == LogicRef) and: [ea isLogicGround not])
			ifTrue: [aSet add: ea]].

	^ false! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 16:27'!
isInfix

	^ type size = 3! !

!LogicDontCare methodsFor: 'as yet unclassified' stamp: 'spfa 10/8/2022 00:26'!
isLogicGround

	^ false! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 9/29/2022 20:31'!
isLogicGround

	^ self isUnbound not! !

!LogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 11:13'!
isLogicGround

	^ killer notNil and: [killer isLogicGround]! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 9/29/2022 20:17'!
isLogicGround

	^ true! !

!PrologList methodsFor: 'testing' stamp: 'spfa 9/29/2022 20:16'!
isLogicGround

	self doWithCdr: [:car :cdr | 
		car isLogicGround ifFalse: [^ false].
		cdr isLogicGround ifFalse: [^ false]].
	
	^ true! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 16:27'!
isPostfix

	^ type last = $f! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 16:27'!
isPrefix

	^ type first = $f! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 9/27/2022 14:50'!
isPrologList

	^ false! !

!PrologList methodsFor: 'testing' stamp: 'spfa 9/27/2022 14:50'!
isPrologList

	^ true! !

!PrologList methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:15'!
isRelation

	^ false! !

!Relation methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:16'!
isRelation

	^ true! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 10:45'!
isUnbound

	^ (self lastNode logicValue class == LogicUnbound)
		and: [self lastNode logicValue isLogicGround not]! !

!LogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 11:13'!
killer

	^ killer! !

!LogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 10:37'!
killer: anObject

	killer := anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
lastNode
    | aNode |
    aNode := self.
    [aNode content class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!LogicRef methodsFor: 'conversion' stamp: 'spfa 10/3/2022 23:33'!
logicInstanciated

	^ self logicValue logicInstanciated! !

!LogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 10:47'!
logicInstanciated

	killer ifNil: [^ self] ifNotNil: [^ killer logicInstanciated]! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 9/28/2022 22:08'!
logicInstanciated

	^ self ! !

!PrologList methodsFor: 'as yet unclassified' stamp: 'spfa 9/28/2022 22:09'!
logicInstanciated

	^ self class 
		head: self head logicInstanciated 
		tail: self tail logicInstanciated
   ! !

!LogicResult methodsFor: 'accessing' stamp: 'spfa 9/28/2022 11:43'!
logicResult

	^ value! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 9/27/2022 14:30'!
logicResult

	^ self! !

!NamedLogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:43'!
logicUnboundPrintString

	^ '#Unbound', uhash! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 9/29/2022 02:16'!
logicValue

    ^ self lastNode content! !

!LogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 10:38'!
logicValue

	killer ifNil: [^ self] ifNotNil: [^ killer logicValue]! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:15'!
logicValue

	^ self ! !

!Logic class methodsFor: 'utils' stamp: 'spfa 10/13/2022 00:00'!
makeLogicSelector: aString

	^ (self prologKeyword, aString capitalized) asSymbol! !

!PrologOperator class methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2022 10:49'!
named: aSymbol

"TMP - hardcoded at the moment
should be dynamic
and class-dependent

also, currently no support for same-name operators with different types (+ - for example) "

	^ aSymbol caseOf: {

		[#':-'] -> [self new operator: #':-'; precedence: 1200; type: #xfx].
		[#','] -> [self new operator: #','; precedence: 1000; type: #yfx].
		"DCG parsing"
		[#-->] -> [self new operator: #-->; precedence: 1200; type: #xfx].


		"arithmetic"
		[#+] -> [self new operator: #+; precedence: 500; type: #yfx]. 
		[#-] -> [self new operator: #-; precedence: 500; type: #yfx].
		[#*] -> [self new operator: #*; precedence: 400; type: #yfx].
		[#/] -> [self new operator: #/; precedence: 400; type: #yfx].

		[#\+] -> [self new operator: #\+; precedence: 900; type: #fy].

		[#is] -> [self new operator: #is; precedence: 700; type: #xfx].

		[#=] -> [self new operator: #=; precedence: 700; type: #xfx].
		[#=**] -> [self new operator: #=**; precedence: 700; type: #xfx].
		[#=<] -> [self new operator: #=<; precedence: 700; type: #xfx].
		[#>=] -> [self new operator: #>=; precedence: 700; type: #xfx].
		[#<] -> [self new operator: #<; precedence: 700; type: #xfx].
		[#>] -> [self new operator: #>; precedence: 700; type: #xfx].
		[#==] -> [self new operator: #==; precedence: 700; type: #xfx].
		[#\==] -> [self new operator: #\==; precedence: 700; type: #xfx].
		[#===] -> [self new operator: #===; precedence: 700; type: #xfx].
	}
	otherwise: [nil]! !

!Logic class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new initialize! !

!LogicRef class methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
new
    ^super new content: LogicUnbound new! !

!LogicRef class methodsFor: 'accessing' stamp: 'spfa 9/27/2022 14:15'!
newTerm: aTerm
    ^ self new term: aTerm! !

!Logic methodsFor: 'private' stamp: 'spfa 9/29/2022 10:27'!
noteUnboundVar: aLogicRef

	 unboundVars add: aLogicRef! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 11:50'!
operator

	^ operator! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 11:50'!
operator: aSymbol

	operator := aSymbol! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
outputStream

	^ outputStream ifNil: [outputStream := WriteStream on: '']! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
outputStream: aWriteStream

	outputStream := aWriteStream! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 21:57'!
precedence

	^ precedence! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 21:57'!
precedence: aNumber

	precedence := aNumber! !

!Collection methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:08'!
printElementsForPrologOn: aStream
	aStream nextPut: $(.
	self do: [:element | element printForPrologOn: aStream. aStream space].
	self isEmpty ifFalse: [aStream skip: -1].
	aStream nextPut: $)! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:15'!
printForPrologOn: aStream

	self printOn: aStream! !

!PrologList methodsFor: 'printing' stamp: 'spfa 9/30/2022 11:47'!
printForPrologOn: aStream
    aStream nextPut: $[.
    self printOne: aStream with: ', '.
    car ifNotNil: [aStream skip: -3].
    aStream nextPut: $]! !

!Relation methodsFor: 'printing' stamp: 'spfa 9/30/2022 11:48'!
printForPrologOn: aStream
	car isSymbol
		ifTrue: [aStream nextPutAll: car]
		ifFalse: [car printOn: aStream].
    aStream nextPut: $(.
    (cdr isConsCell)
        ifTrue: [cdr printOne: aStream with: ', '. cdr ifNotNil: [aStream skip: -3]]
        ifFalse: [cdr ifNotNil: [cdr printOn: aStream]].
    aStream nextPut: $)! !

!Symbol methodsFor: '*Prolog-Base' stamp: 'spfa 10/3/2022 21:21'!
printForPrologOn: aStream

	aStream nextPutAll: self! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:17'!
printForPrologOn: aStream

	aStream nextPutAll: '[]'! !

!LogicDontCare methodsFor: 'accessing' stamp: 'spfa 9/30/2022 11:49'!
printOn: aStream
    aStream nextPut: $_! !

!LogicRef methodsFor: 'printing' stamp: 'spfa 10/13/2022 11:24'!
printOn: aStream

	"Is it a good idea to print a LogicRef just as a LogicResult?"

	aStream nextPutAll: self term.

	self isUnbound ifTrue: [^ self].

	aStream nextPutAll: ' = '.
   	self logicValue printForPrologOn: aStream.
	aStream nextPut: $.! !

!LogicResult methodsFor: 'printing' stamp: 'spfa 9/28/2022 11:44'!
printOn: aStream

	aStream nextPutAll: self term.
	aStream nextPutAll: ' = '.
   	self logicResult printForPrologOn: aStream.
	aStream nextPut: $.! !

!LogicUnbound methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:11'!
printOn: aStream
    #Unbound printOn: aStream.
	self hash printOn: aStream
! !

!LogicUnification methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:06'!
printOn: aStream

	terms do: [:term |
		aStream nextPutAll: term.
		aStream nextPutAll: ' = '].
	aStream skip: -3.
	aStream nextPut: $.! !

!NamedLogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:42'!
printOn: aStream
    
	aStream nextPutAll: term! !

!PrologList methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:15'!
printOn: aStream

	self printForPrologOn: aStream
    ! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/14/2022 15:44'!
printOn: aStream

	aStream nextPutAll: self operator; nextPut: $[.
	self precedence printOn: aStream.
	aStream nextPut: $,; nextPutAll: self type.
	aStream nextPut: $]
! !

!PrologList methodsFor: 'printing' stamp: 'spfa 10/13/2022 10:48'!
printOne: aStream with: separators

	self printThis: car on: aStream.
	aStream nextPutAll: separators.
	(cdr isConsCell)
		ifTrue: [cdr printOne: aStream with: separators]
		ifFalse: [cdr ifNil: [aStream nextPutAll: '*'. ^ self].
			aStream skip: -2.
	            aStream nextPutAll: '|'.
			self printThis: cdr on: aStream.
			aStream nextPutAll: '***']! !

!PrologList methodsFor: 'printing' stamp: 'spfa 10/13/2022 10:47'!
printThis: anObject on: aStream

	(anObject class == LogicRef and: [anObject isAutoReferential]) 
		ifTrue: [aStream nextPutAll: anObject term] 
		ifFalse: [anObject printForPrologOn: aStream].
! !

!Logic class methodsFor: 'predicates' stamp: 'spfa 11/18/2009 18:11'!
prologKeyword

	^ 'logic'
! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:15'!
prologPrintString

	^ String streamContents: [:s | self printForPrologOn: s]! !

!PrologDatabase methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2022 09:06'!
purge: aSymbol

	self removeKey: aSymbol ifAbsent: []! !

!Logic class methodsFor: 'predicates' stamp: 'spfa 10/4/2022 22:15'!
readPredicate: aString

	"Predicates are encoded in different forms - for example true can appear as 'true', 'logicTrue', or 'primlogicTrue' depending on the parsing context"

	| symb |

	symb := aString asSymbol.

	^ self binaryPredicates at: symb ifAbsent: [

		 self predicates at: symb ifAbsent: [ | logicSymb primlogicSymb pred |

			(symb beginsWith: ('prim', self prologKeyword)) ifTrue: 
				[self predicates at: symb put: symb. ^ symb].

			(symb beginsWith: self prologKeyword) ifTrue: [
				symb := (symb allButFirst: self prologKeyword size) 
								withFirstCharacterDownshifted].

			symb last == $: ifTrue: [symb := symb allButLast].
			symb := symb asSymbol.

			logicSymb := self makeLogicSelector: symb.	
			primlogicSymb := ('prim', logicSymb, ':') asSymbol.

			pred := (self canUnderstand: logicSymb)
				ifTrue: [logicSymb] ifFalse: [
					(self canUnderstand: primlogicSymb)
						ifTrue: [primlogicSymb] ifFalse: [symb]].

			self predicates at: symb put: pred.
			self predicates at: logicSymb put: pred.
			pred == primlogicSymb
				ifTrue: [self predicates at: primlogicSymb put: pred].

			^ pred]]
! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 11:46'!
resorbBoundSlot

	"dynamic clean-up of bound slots - see sender"

    	| lastNode |

	lastNode := self lastNode.
	((lastNode content class == LogicUnbound)
		and: [lastNode content killer notNil])
			ifTrue: [lastNode content: lastNode content killer].
	^ lastNode! !

!LogicRef methodsFor: 'conversion' stamp: 'spfa 10/1/2022 14:27'!
resultCopy

	^ self deepCopy
! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 10/3/2022 15:28'!
resultCopy

	^ self 
! !

!PrologList methodsFor: 'as yet unclassified' stamp: 'spfa 10/1/2022 14:22'!
resultCopy

	^ self copy setcar: car resultCopy; setcdr: cdr resultCopy

! !

!Logic methodsFor: 'query' stamp: 'spfa 11/18/2009 18:11'!
retrieve: assoc from: dataList
        "Retrieve a fact in assoc from
         Database entry dataList."

    (dataList ifNil: [^self]) 
		do: [:elt | self unify: assoc key with: elt then: assoc value]! !

!Array methodsFor: '*Prolog-Base' stamp: 'spfa 10/13/2022 00:43'!
reverseDoWithIndex: aBlock

	self size to: 1 by: -1 do: [:index | aBlock value: (self at: index) value: index]! !

!Logic methodsFor: 'private' stamp: 'spfa 11/18/2009 18:11'!
second: assoc
        "Private -- Answer the second argument."
    ^ assoc key tail head logicValue! !

!Logic class methodsFor: 'predicates' stamp: 'spfa 10/4/2022 21:56'!
selectorForBinaryPredicate: aSymbol

	^ self binaryPredicates at: aSymbol ifAbsent: [self error: 'Undefined binary predicate: ', aSymbol]! !

!LogicDontCare methodsFor: 'parser support' stamp: 'bolot 7/19/1999 17:55'!
size
	" symbol used for LogicDontCare is ':=' (underscore) "
	^self printString size! !

!Logic methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:11'!
structureHead: aSymbol arguments: anInteger
        "Answer a structure whose functor is
         aSymbol and arguments are anInteger
         number of DontCares."
    | aRelation |
    aRelation := Relation with: aSymbol.
    anInteger timesRepeat: [
        aRelation addLast: LogicDontCare new].
    ^aRelation! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 11/18/2009 18:15'!
tail
    ^cdr! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 11/18/2009 18:17'!
tail

	^ nil! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 11/18/2009 18:15'!
tail: anObject
    self cdr: anObject! !

!Relation methodsFor: 'private' stamp: 'spfa 11/18/2009 18:16'!
tailClass

	^ PrologList

! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 9/27/2022 14:56'!
term

	^ term ifNil: ['?']! !

!LogicResult methodsFor: 'accessing' stamp: 'spfa 9/28/2022 11:43'!
term

	^ key ifNil: ['?']! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 9/27/2022 14:13'!
term: aString

	term := aString! !

!LogicResult methodsFor: 'accessing' stamp: 'spfa 9/28/2022 11:43'!
term: aString

	key := aString! !

!NamedLogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:39'!
term: aString

	term := aString! !

!LogicUnification methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:05'!
terms: aCollection

	terms := aCollection! !

!Logic methodsFor: 'private' stamp: 'spfa 11/18/2009 18:11'!
third: assoc
        "Private -- Answer the third argument."
    ^ assoc key tail tail head logicValue! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 21:57'!
type

	^ type! !

!PrologOperator methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2022 21:57'!
type: aSymbol

	type := aSymbol! !

!NamedLogicUnbound methodsFor: 'as yet unclassified' stamp: 'spfa 10/3/2022 23:41'!
uhash: anInteger

	uhash := anInteger! !

!Logic methodsFor: 'private' stamp: 'mt 6/28/1999 12:00'!
unbindVar: mark
        "Private -- Unbind previously bound variables
         down to mark."
    | index |
    [(index := unboundVars size) > mark]
        whileTrue: [
            (unboundVars at: index)
                content: LogicUnbound new.
            unboundVars removeLast]! !

!LogicDontCare methodsFor: 'as yet unclassified' stamp: 'spfa 9/29/2022 10:11'!
unifiesWith: anObject asPerLogic: aLogic

	^ true! !

!LogicRef methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 11:24'!
unifiesWith: anObject asPerLogic: aLogic

 	anObject class == LogicDontCare ifTrue: [^ true].

	self isUnbound ifTrue: [
		aLogic noteUnboundVar: self.
		self getValueFrom: anObject.
		^ true].

	^ self logicValue unifiesWith: anObject asPerLogic: aLogic! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 9/29/2022 11:01'!
unifiesWith: anObject asPerLogic: aLogic

 	anObject class == LogicDontCare ifTrue: [^ true].

	anObject class == LogicRef ifTrue: [
		^ anObject unifiesWith: self asPerLogic: aLogic].

	^ self = anObject! !

!PrologList methodsFor: 'testing' stamp: 'spfa 9/29/2022 11:32'!
unifiesWith: anObject asPerLogic: aLogic

	self class == anObject class 
		ifFalse: [^ super unifiesWith: anObject asPerLogic: aLogic].

	(self head unifiesWith: anObject head asPerLogic: aLogic) ifFalse: [^ false].
     ^ self tail unifiesWith: anObject tail asPerLogic: aLogic! !

!Logic methodsFor: 'query' stamp: 'spfa 9/29/2022 11:34'!
unify: x with: y then: aBlock
        "Private -- If x unifies with y, then execute
         aBlock. Answer self."
	| mark blk |
   	mark := unboundVars size.
	blk := aBlock.
  	 (x unifiesWith: y asPerLogic: self) ifTrue: [[(blk := blk value) isBlock] whileTrue].
    	self unbindVar: mark! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
with: anObject
    ^self car: anObject! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
with: anObject with: bObject
    ^self car: anObject cdr: (self car: bObject)! !

!LogicResult methodsFor: 'accessing' stamp: 'spfa 9/28/2022 11:44'!
wrapAround: anObject

	value := anObject! !
Logic initialize!
