SystemOrganization addCategory: #'Prolog-Documentation'!


Prolog subclass: #FisherTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

FisherTutorial class
	instanceVariableNames: ''!

FisherTutorial subclass: #Chapter2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

FisherTutorial subclass: #Chapter3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

Chapter3 class
	instanceVariableNames: ''!

Prolog subclass: #Metalevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

Metalevel class
	instanceVariableNames: ''!

Chapter2 class
	instanceVariableNames: ''!

FisherTutorial subclass: #Chapter5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

Chapter5 class
	instanceVariableNames: ''!


!Chapter2 commentStamp: 'spfa 2/26/2017 11:25' prior: 0!
Implements code from the chapter 2 of
https://www.cpp.edu/~jrfisher/www/prolog_tutorial/contents.html

Note that this interpreter uses an instance-local database!
]style[(161)!

!Chapter3 commentStamp: 'spfa 2/26/2017 11:25' prior: 0!
Implements code from the chapter 3 of
https://www.cpp.edu/~jrfisher/www/prolog_tutorial/contents.html
!
]style[(102)!

!FisherTutorial commentStamp: 'spfa 2/26/2017 11:25' prior: 0!
This class and its subclasses implements code from the on-line Prolog tutorial at:
https://www.cpp.edu/~jrfisher/www/prolog_tutorial/contents.html!
]style[(146)!

!Metalevel commentStamp: 'spfa 10/7/2022 18:27' prior: 0!
This class implements code from the "The Power of Prolog" at: https://www.metalevel.at/prolog!
]style[(93)!

!Chapter2 class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:07'!
databaseScope

	"(cleaner) ...so that the animals game does not alter any global state"
	^ #instanceLocal! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicAlbatross

albatross :- bird,
             verify('appear in story Ancient Mariner'),
             verify('fly well').! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/11/2022 10:37'!
logicAlphaBeta

alphaBeta(Player,0,Position,Alpha,Beta,NoMove,Value) :- 
   positionValue(Position,Value).

alphaBeta(Player,D,Position,Alpha,Beta,Move,Value) :- 
   >(D,0), 
   findall([X,Y],mark(Player,Position,X,Y),Moves), 
   iss(Alpha1, beta negated), 
   iss(Beta1, alpha negated),
   iss(D1,d-1), 
   evaluateAndChoose(Player,Moves,Position,D1,Alpha1,Beta1,[],[Move,Value]).

! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 10/4/2022 00:29'!
logicAsk

ask(Question) :-
    write('Does the animal '), write(Question), write(' ? '),
    readstring(Response),
    remember(Question,Response).
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicBird
bird      :- verify('have feathers'), !!.
bird     :- verify('fly'), verify('lay eggs').! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 10/4/2022 00:39'!
logicBlack

black(b).                           
 ! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:56'!
logicC

c :- 
   board(B), 
"   alphaBeta(o,4,B,-200,200,[X,Y],Value), "
   alphaBeta(o,2,B,-200,200,[X,Y],Value), 
   record(o,X,Y), showBoard.
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicCarnivore
carnivore :- verify('eat meat'), !!.
carnivore :- verify('have pointed teeth'), 
             verify('have claws'),
             verify('have forward eyes').! !

!Chapter2 methodsFor: '2.8 change for a dollar' stamp: 'spfa 10/11/2022 10:36'!
logicChange

change([H,Q,D,N,P]) :- 
    member(H,[0,1,2]),                     
    member(Q,[0,1,2,3,4]),                  
    member(D,[0,1,2,3,4,5,6,7,8,9,10]) ,   
    member(N,[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20]),  
    iss(S, (50*h) + (25*q) + (10*d) + (5*n)), 
    =<(S, 100), 
    iss(P,100-s). ! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicCheetah

cheetah :- mammal, carnivore, 
           verify('have tawny color'),
           verify('have dark spots').! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 10/4/2022 00:39'!
logicColor

color(P,'red') :- red(P),!!.
color(P,'black') :- black(P),!!.
color(P,'unknown').                            
 ! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:48'!
logicComment

comment :- 
   board(P), win(P,x), write('human player won.'),nl,!!.

comment :- 
   board(P), win(P,o), write('computer won.'),nl,!!.

comment :- 
   board(P), 	
	findall([X,Y],mark(_,P,X,Y),ValidMoves),\+(=([H|T],ValidMoves)), write('draw.'),nl.

comment :- true.! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 15:42'!
logicCutoff

cutoff(Player,Move,Value,D,Alpha,Beta,Moves,Position,Record,[Move,Value]) :- 
   >=(Value,Beta), !!.

cutoff(Player,Move,Value,D,Alpha,Beta,Moves,Position,Record,BestMove) :- 
   <(Alpha,Value), <(Value,Beta), !!, 
   evaluateAndChoose(Player,Moves,Position,D,Value,Beta,Move,BestMove).

cutoff(Player,Move,Value,D,Alpha,Beta,Moves,Position,Record,BestMove) :- 
   =<(Value,Alpha), !!, 
   evaluateAndChoose(Player,Moves,Position,D,Alpha,Beta,Record,BestMove).
! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 10/4/2022 00:31'!
logicDelta

delta(0,a,1).   
delta(0,b,0).
delta(1,a,1).
delta(1,b,2).
delta(2,a,2).
delta(2,b,2).! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 10/4/2022 00:31'!
logicDemo214

demo214 :-
	write('Parsing bbaabab:'),nl,
	parse([b,b,a,a,b,a,b]),
	write('Parsing bba:'),nl,
 	parse([b,b,a]).! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/11/2022 10:37'!
logicEvaluateAndChoose

evaluateAndChoose(Player,[Move|Moves],Position,D,Alpha,Beta,Record,BestMove) :-
   move(Player,Move,Position,Position1), 
   otherPlayer(Player,OtherPlayer),
   alphaBeta(OtherPlayer,D,Position1,Alpha,Beta,OtherMove,Value),
   iss(Value1, value negated),
   cutoff(Player,Move,Value1,D,Alpha,Beta,Moves,Position,Record,BestMove).

evaluateAndChoose(Player,[],Position,D,Alpha,Beta,Move,[Move,Alpha]).! !

!Chapter2 methodsFor: '2.2 factorial' stamp: 'spfa 10/11/2022 10:36'!
logicFactorial

factorial(0,1). 

factorial(N,F) :-  
   >(N,0), 
   iss(N1, n - 1), 
   factorial(N1,F1), 
   iss(F, n * f1).! !

!Chapter2 methodsFor: '2.2 factorial' stamp: 'spfa 10/11/2022 10:36'!
logicFactorialT

factorialT(0,F,F). 

factorialT(N,A,F) :-  
    >(N,0), 
    iss(A1, n* a), 
    iss(N1, n - 1), 
    factorialT(N1,A1,F).! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 11/18/2009 18:07'!
logicFinal

final(2).! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicGiraffe

giraffe :- ungulate, 
           verify('have long neck'), 
           verify('have long legs').! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 10/4/2022 00:33'!
logicGo

go :- 
      write('Answer yes or no to the following questions...'), nl,
	 hypothesize(Animal),
      write('I guess that the animal is: '),
      write(Animal),nl,undo,fail.! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:37'!
logicGo

go :- init,write('h(X,Y) for human player, c for computer'),nl,s.
! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:56'!
logicH

h(X,Y) :-  record(x,X,Y), showBoard.
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 10/4/2022 00:33'!
logicHypothesize

hypothesize(cheetah) :- cheetah, !!.
hypothesize(tiger) :- tiger, !!.
hypothesize(giraffe)   :- giraffe, !!.
hypothesize(zebra)     :- zebra, !!.
hypothesize(ostrich)   :- ostrich, !!.
hypothesize(penguin)   :- penguin, !!.
hypothesize(albatross) :- albatross, !!.
hypothesize(unknown).  ! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:38'!
logicInit

init :-
	retractall(board),
	assert(board([Z1,Z2,Z3,Z4,Z5,Z6,Z7,Z8,Z9])). ! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicMammal
mammal    :- verify('have hair'), !!.
mammal   :- verify('give milk').! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 16:11'!
logicMark

mark(X) :- var(X), write('#').
mark(X) :- not(var(X)), write(X).

"
%%%%%
%%  Generate possible marks on a free spot on the board.
%%  Use mark(+,+,-X,-Y) to query/generate possible moves (X,Y).
%%%%%
"
mark(Player, [X|_],1,1) :- var(X), =(X,Player).
mark(Player, [_,X|_],2,1) :- var(X), =(X,Player).
mark(Player, [_,_,X|_],3,1) :- var(X), =(X,Player).
mark(Player, [_,_,_,X|_],1,2) :- var(X), =(X,Player).
mark(Player, [_,_,_,_,X|_],2,2) :- var(X), =(X,Player).
mark(Player, [_,_,_,_,_,X|_],3,2) :- var(X), =(X,Player).
mark(Player, [_,_,_,_,_,_,X|_],1,3) :- var(X), =(X,Player).
mark(Player, [_,_,_,_,_,_,_,X|_],2,3) :- var(X), =(X,Player).
mark(Player, [_,_,_,_,_,_,_,_,X],3,3) :- var(X), =(X,Player).! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 16:20'!
logicMove

"
%%%%%
%%  Move 
%%%%%
"
move(P,[1,1],[X1|R],[P|R]) :- var(X1).
move(P,[2,1],[X1,X2|R],[X1,P|R]) :- var(X2).
move(P,[3,1],[X1,X2,X3|R],[X1,X2,P|R]) :- var(X3).
move(P,[1,2],[X1,X2,X3,X4|R],[X1,X2,X3,P|R]) :- var(X4).
move(P,[2,2],[X1,X2,X3,X4,X5|R],[X1,X2,X3,X4,P|R]) :- var(X5).
move(P,[3,2],[X1,X2,X3,X4,X5,X6|R],[X1,X2,X3,X4,X5,P|R]) :- var(X6).
move(P,[1,3],[X1,X2,X3,X4,X5,X6,X7|R],[X1,X2,X3,X4,X5,X6,P|R]) :- var(X7).
move(P,[2,3],[X1,X2,X3,X4,X5,X6,X7,X8|R],[X1,X2,X3,X4,X5,X6,X7,P|R]) :- var(X8).
move(P,[3,3],[X1,X2,X3,X4,X5,X6,X7,X8,X9|R],[X1,X2,X3,X4,X5,X6,X7,X8,P|R]) :- var(X9).! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:41'!
logicOpen

"
%%%%% 
%%  A line is open if each position is either free or equals the Player
%%%%%
"
open([Z1,Z2,Z3|_],P) :- or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([_,_,_,Z1,Z2,Z3|_],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([_,_,_,_,_,_,Z1,Z2,Z3],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([Z1,_,_,Z2,_,_,Z3,_,_],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([_,Z1,_,_,Z2,_,_,Z3,_],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([_,_,Z1,_,_,Z2,_,_,Z3],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([Z1,_,_,_,Z2,_,_,_,Z3],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
open([_,_,Z1,_,Z2,_,Z3,_,_],P) :-  or(var(Z1), ==(Z1,P)),or(var(Z2), ==(Z2,P)), or(var(Z3), ==(Z3,P)).
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicOstrich

ostrich :- bird,  
           verify('run only, not fly'), 
           verify('have long neck').! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:42'!
logicOtherPlayer


otherPlayer(o,x).
otherPlayer(x,o).! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 10/4/2022 00:38'!
logicP

p(a).                        
p(X) :- q(X), r(X).            
p(X) :- u(X).  ! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 00:07'!
logicPalindrome

palindrome --> [].
palindrome --> [_].
palindrome --> [E], palindrome , [E].! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 00:18'!
logicPalindromeExpanded

palindromeExpanded(S0,S) :- =(S0,S).
palindromeExpanded(S0,S) :- cccc(S0, _, S).
palindromeExpanded(S0,S) :- cccc(S0, E, S1), palindromeExpanded(S1,S2) , cccc(S2, E, S).! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 10/4/2022 00:33'!
logicParse

parse(L) :- start(S), 
	trans(S,L).! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicPenguin

penguin :- bird,  
           verify('hardly fly'), 
           verify('swim'), 
           verify('have black and white colors').! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 10/4/2022 00:34'!
logicPerm

perm([X|Y],Z) :- perm(Y,W), takeout(X,Z,W).   

perm([],[]).! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/11/2022 10:37'!
logicPositionValue

"
%%%%%
%% Calculate the value of a position, o maximizes, x minimizes.
%%%%%
"
positionValue(Board,100) :- win(Board,o), !!.

positionValue(Board,-100) :- win(Board,x), !!.

positionValue(Board,E) :- 
   findall(o,open(Board,o),MAX), 
   length(MAX,Emax),      
   findall(x,open(Board,x),MIN), 
   length(MIN,Emin),   
   iss(E,emax - emin).! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 10/4/2022 00:38'!
logicQ

q(X) :- s(X). ! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 10/4/2022 00:38'!
logicR

r(a).                          
r(b).                            
 ! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:42'!
logicRecord

"
%%%%%
%%  Record a move: record(+,+,+).
%%%%%
"

record(Player,X,Y) :- 
   retract(board(B)), 
   mark(Player,B,X,Y),
   assert(board(B)).! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 10/4/2022 00:39'!
logicRed

red(a).                           
 ! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 10/4/2022 00:34'!
logicRemember

remember(Question,'yes') :- assert(yes(Question)).
remember(Question,'y') :- assert(yes(Question)).
remember(Question,:=) :- assert(no(Question)), fail.! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/12/2022 15:37'!
logicReversal

"an example of definite clause grammar"

reversal([]) --> [].
reversal([Token|Rest]) --> reversal(Rest), [Token].! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 00:18'!
logicReversal2

"dummy, for testing parsing only"

reversal2([]) --> [].
reversal2([Token|Rest]) --> reversal2(Rest), [Token], [_].! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 10/4/2022 00:35'!
logicReverse

reverse([X|Y],Z,W) :- reverse(Y,[X|Z],W).
reverse([],X,X).
reverse(A,R) :- reverse(A,[],R).! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 10/4/2022 00:39'!
logicS

s(a).      
s(b).          
s(c).                           
 ! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 9/30/2022 01:53'!
logicS

s :- showBoard.! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/12/2022 01:10'!
logicSentence

sentence --> noun, verbPhrase.
! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/12/2022 01:21'!
logicSeq

seq([])     --> [].
seq([E|Es]) --> [E], seq(Es).! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:43'!
logicShowBoard

showBoard :- 
   board([Z1,Z2,Z3,Z4,Z5,Z6,Z7,Z8,Z9]), 
	nl,
   write('    '),mark(Z1),write(' '),mark(Z2),write(' '),mark(Z3),nl,
   write('    '),mark(Z4),write(' '),mark(Z5),write(' '),mark(Z6),nl,
   write('    '),mark(Z7),write(' '),mark(Z8),write(' '),mark(Z9),nl,
	comment.! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 11/18/2009 18:07'!
logicStart

start(0).! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 10/4/2022 00:36'!
logicTakeout

takeout(X,[X|R],R).
takeout(X,[F|R],[F|S]) :- takeout(X,R,S).! !

!Metalevel methodsFor: 'as yet unclassified' stamp: 'spfa 10/12/2022 01:10'!
logicTest

test(5,6,7).! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicTiger

tiger :- mammal, carnivore, 
           verify('have tawny color'),
           verify('have black stripes').! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 10/4/2022 00:37'!
logicTrans

trans(X,[A|B]) :- 
      delta(X,A,Y),   
      write(X),
      write('  '),
      write([A|B]),
      nl,
      trans(Y,B).  
trans(X,[]) :- 
      final(X),
      write(X),
      write('  '),
      write([]), nl.
! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 10/4/2022 00:39'!
logicU

u(d).                           
 ! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicUndo
undo :- retract(yes(:=)),retract(no(:=)).
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicUngulate
ungulate :- mammal, verify('have hooves'), !!.
ungulate :- mammal, verify('chew cud').! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 10/4/2022 00:38'!
logicVerify

verify(S) :- database(yes()),yes(S), true.
verify(S) :- database(no()),no(S), fail.
verify(S) :- or(yes(S),or(no(S),ask(S))).
! !

!Chapter5 methodsFor: '5.3 tic tac toe' stamp: 'spfa 10/4/2022 10:47'!
logicWin

"
%%%%% 
%%  A winning line is ALREADY bound to Player. 
%%  win(+Board,+Player) is true or fail.
%%    e.g., win([P,P,P|_],P).  is NOT correct, because could bind 
%%%%%
"
win([Z1,Z2,Z3|_],P) :- ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([_,_,_,Z1,Z2,Z3|_],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([_,_,_,_,_,_,Z1,Z2,Z3],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([Z1,_,_,Z2,_,_,Z3,_,_],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([_,Z1,_,_,Z2,_,_,Z3,_],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([_,_,Z1,_,_,Z2,_,_,Z3],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([Z1,_,_,_,Z2,_,_,_,Z3],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
win([_,_,Z1,_,Z2,_,Z3,_,_],P) :-  ==(Z1,P), ==(Z2,P), ==(Z3,P).
! !

!Chapter2 methodsFor: '2.17 animals game' stamp: 'spfa 11/18/2009 18:07'!
logicZebra

zebra :- ungulate, verify('has black stripes').! !
