'From Squeak3.10.2 of ''5 June 2008'' [latest update: #7179] on 17 August 2009 at 2:04:55 pm'!
Smalltalk renameClassNamed: #PluggableReplSpec as: #PluggableMorphSpec!
PluggableWidgetSpec subclass: #PluggableMorphSpec
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Tools'!

!MorphicToolBuilder methodsFor: '*Prolog-tools' stamp: 'spfa 8/16/2009 23:44'!
buildMorphSpec: aSpec

	self setFrame: aSpec frame in: aSpec morph.
	parent ifNotNil:[self add: aSpec morph to: parent].

	^aSpec morph! !


!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:41'!
buildWith: builder

	^ builder buildMorphSpec: self
	! !

!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:43'!
morph

	^ morph ! !

!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:43'!
morph: aMorph

	morph _ aMorph! !


!Prolog methodsFor: 'interaction' stamp: 'spfa 8/17/2009 13:53'!
gui

	^ PrologBrowser for: self
! !


!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:02'!
classListIndex: anInteger 

	super classListIndex: anInteger .
	self selectedClass ifNil: [^self].
	(self selectedClass == Prolog
		or: [self selectedClass inheritsFrom: Prolog])
		ifTrue: [self repl evaluator: self selectedClass new]
	! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 8/17/2009 00:08'!
openSystemCatEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers.  The top list view is of the currently selected system class category--a single item list."
	"Example:
		Browser new browseAllClasses.
	"
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue:[0.32] ifFalse:[0.4].
	^self buildWindowWith: builder specs: {
		(0.0@0.0 corner: 0.333@(max-0.1)) -> [self buildClassListWith: builder].
		(0.0@(max-0.1) corner: 0.333@max) -> [self buildSwitchesWith: builder].
		(0.333@0.0 corner: 0.666@max) -> [self buildMessageCategoryListWith: builder].
		(0.666@0.0 corner: 1@max) -> [self buildMessageListWith: builder].
		(0@max corner: 1@0.8) -> [self buildCodePaneWith: builder].
		(0@0.8 corner: 1@1) -> [PluggableMorphSpec new morph: self repl].
	}! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:04'!
repl

	^ repl ifNil: [repl _ PrologREPLMorph on: Prolog new]! !


!PrologBrowser class methodsFor: 'as yet unclassified' stamp: 'spfa 8/17/2009 13:57'!
for: aProlog
	"Return a new PrologBrowser on the given class"
	|  newBrowser window |
	newBrowser := PrologBrowser new initHierarchyForClass: Prolog.
	newBrowser selectClass: aProlog class..
	newBrowser repl: (PrologREPLMorph on: aProlog).
	newBrowser editSelection: #editComment.
	window _ MorphicToolBuilder new build: (newBrowser openSystemCatEditString: nil).
	window setLabel: newBrowser labelString, ' & REPL' .
	^ window
! !

!PrologBrowser class methodsFor: 'as yet unclassified' stamp: 'spfa 8/17/2009 13:59'!
newFor: aPrologClass
	"Open a new PrologBrowser on the given class"
	|  newBrowser |
	newBrowser := PrologBrowser new initHierarchyForClass: Prolog.
	newBrowser selectClass: aPrologClass..
	newBrowser repl: (PrologREPLMorph on: aPrologClass new).
	newBrowser editSelection: #editComment.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: newBrowser labelString, ' & REPL' 
! !


!MorphicToolBuilder reorganize!
('opening' close: open: open:label: runModal:)
('pluggable widgets' buildPluggableActionButton: buildPluggableButton: buildPluggableInputField: buildPluggableList: buildPluggableMultiSelectionList: buildPluggablePanel: buildPluggableText: buildPluggableTree: buildPluggableWindow:)
('private' add:to: asFrame: register:id: setFrame:in: setLayout:in: widgetAt:ifAbsent:)
('building' buildPluggableMenu: buildPluggableMenuItem:)
('*Prolog-tools' buildMorphSpec:)
!

